Imports System.ComponentModel
Imports System.ComponentModel.Design

Imports System.Windows.Forms

Namespace PCpress.Forms.Controls
    <Designer(GetType(System.Windows.Forms.Design.ParentControlDesigner), GetType(IDesigner)), _
              DesignTimeVisibleAttribute(True), DefaultProperty("Text"), DefaultEvent("Click")> _
        Public Class PCPressFormTitle
        Inherits System.Windows.Forms.Panel

#Region "Private fields"
        Private mTextAlign As ContentAlignment = ContentAlignment.MiddleCenter
        Private mTextQuality As PCpressEnums.TextRendering = PCpressEnums.TextRendering.SystemDefault
        Private mBorderNormal As Boolean = False
        Private mBorderHover As Boolean = False
        Private mBorderSelected As Boolean = True
        Private mBorderNormalColor As Color = Color.FromArgb(179, 176, 208)
        Private mBorderHoverColor As Color = Color.FromArgb(179, 176, 208)
        Private mBorderSelectedColor As Color = Color.Blue
        Private mBackColor1 As Color = Color.FromArgb(221, 236, 254)
        Private mBackColor2 As Color = Color.FromArgb(129, 169, 226)
        Private mHoverColor1 As Color = Color.FromArgb(255, 244, 204)
        Private mHoverColor2 As Color = Color.FromArgb(255, 208, 145)
        Private mSelectedColor1 As Color = Color.FromArgb(255, 213, 140)
        Private mSelectedColor2 As Color = Color.FromArgb(255, 173, 85)
        Private mSelectedHoverColor1 As Color = Color.FromArgb(254, 145, 78)
        Private mSelectedHoverColor2 As Color = Color.FromArgb(255, 211, 142)
        Private mClickColor1 As Color = Color.FromArgb(254, 145, 78)
        Private mClickColor2 As Color = Color.FromArgb(255, 211, 142)
        Private mGradientMode As Drawing2D.LinearGradientMode = Drawing2D.LinearGradientMode.Vertical
        Private mClose As Image
        Private mCloseAlign As ContentAlignment = ContentAlignment.MiddleRight
        Private mImage As Image = Nothing
        Private mImageAlign As ContentAlignment = ContentAlignment.MiddleLeft
        Private mImageSelected As Image = Nothing
        Private mHoverForeColor As Color = Color.Blue
        Private mMax As Boolean = True
        Private mMin As Boolean = True
        Private Stanje As Boolean
        Private f As New Form
        'Private mMax As Boolean
        'Private mMin As Boolean
        'Private mKontrol As Boolean
        'Private mTooltipText As String = String.Empty

        Public Enum HoverButtonType
            HoverNormal
            HoverCheck
            HoverOption
        End Enum
        Private mButtonType As HoverButtonType = HoverButtonType.HoverNormal
        Private mSelected As Boolean = False
        Private mOptionGroup As Integer = 0

        Private mColorDefault As Color = Color.Blue
        Private mDoClick As Boolean = False
        Private mMouseHover As Boolean = False

        Private mToolTip As ToolTip = New ToolTip
        Private mToolTipActive As Boolean = False
        Private mToolTipText As String = ""

#End Region

#Region "Component Designer generated code"

        Public Sub New()
            MyBase.New()

            ' This call is required by the Component Designer.
            InitializeComponent()

            'Add any initialization after the InitializeComponent() call

            ' This draws the control whenever it is resized
            setstyle(ControlStyles.ResizeRedraw, True)

            ' This supports mouse movement such as the mouse wheel
            setstyle(ControlStyles.UserMouse, True)

            ' This allows the control to be transparent
            setstyle(ControlStyles.SupportsTransparentBackColor, True)

            ' This helps with drawing the control so that it doesn't flicker
            Me.SetStyle(ControlStyles.DoubleBuffer _
              Or ControlStyles.UserPaint _
              Or ControlStyles.AllPaintingInWmPaint, _
              True)

            ' This control is a container
            setstyle(ControlStyles.ContainerControl, False)

            ' This updates the styles
            Me.UpdateStyles()

        End Sub

        'Control overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            MyBase.Dispose(disposing)
        End Sub

        'Required by the Control Designer

        ' NOTE: The following procedure is required by the Component Designer
        ' It can be modified using the Component Designer.  Do not modify it
        ' using the code editor.
        Private components As System.ComponentModel.IContainer
        Friend WithEvents KontrolniOkvir As System.Windows.Forms.Panel
        Friend WithEvents btnclose As System.Windows.Forms.Button
        Friend WithEvents btnMax As System.Windows.Forms.Button
        Friend WithEvents btnMin As System.Windows.Forms.Button
        Friend WithEvents IM As System.Windows.Forms.ImageList
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(PCPressFormTitle))
            Me.KontrolniOkvir = New System.Windows.Forms.Panel
            Me.btnclose = New System.Windows.Forms.Button
            Me.btnMin = New System.Windows.Forms.Button
            Me.btnMax = New System.Windows.Forms.Button
            Me.IM = New System.Windows.Forms.ImageList(Me.components)
            Me.KontrolniOkvir.SuspendLayout()
            '
            'KontrolniOkvir
            '
            Me.KontrolniOkvir.BackColor = System.Drawing.Color.Transparent
            Me.KontrolniOkvir.Controls.Add(Me.btnclose)
            Me.KontrolniOkvir.Controls.Add(Me.btnMin)
            Me.KontrolniOkvir.Controls.Add(Me.btnMax)
            Me.KontrolniOkvir.Dock = System.Windows.Forms.DockStyle.Right
            Me.KontrolniOkvir.Location = New System.Drawing.Point(283, 17)
            Me.KontrolniOkvir.Name = "KontrolniOkvir"
            Me.KontrolniOkvir.Size = New System.Drawing.Size(72, 24)
            Me.KontrolniOkvir.TabIndex = 14
            '
            'btnclose
            '
            Me.btnclose.BackColor = System.Drawing.Color.Transparent
            Me.btnclose.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.btnclose.FlatStyle = System.Windows.Forms.FlatStyle.Flat
            Me.btnclose.Image = CType(resources.GetObject("btnclose.Image"), System.Drawing.Image)
            Me.btnclose.Location = New System.Drawing.Point(17, 17)
            Me.btnclose.Name = "btnclose"
            Me.btnclose.Size = New System.Drawing.Size(21, 21)
            Me.btnclose.TabIndex = 15
            '
            'btnMin
            '
            Me.btnMin.BackColor = System.Drawing.Color.Transparent
            Me.btnMin.FlatStyle = System.Windows.Forms.FlatStyle.Flat
            Me.btnMin.Image = CType(resources.GetObject("btnMin.Image"), System.Drawing.Image)
            Me.btnMin.Location = New System.Drawing.Point(198, 17)
            Me.btnMin.Name = "btnMin"
            Me.btnMin.Size = New System.Drawing.Size(21, 21)
            Me.btnMin.TabIndex = 13
            '
            'btnMax
            '
            Me.btnMax.BackColor = System.Drawing.Color.Transparent
            Me.btnMax.DialogResult = System.Windows.Forms.DialogResult.Cancel
            Me.btnMax.FlatStyle = System.Windows.Forms.FlatStyle.Flat
            Me.btnMax.Image = CType(resources.GetObject("btnMax.Image"), System.Drawing.Image)
            Me.btnMax.Location = New System.Drawing.Point(110, 17)
            Me.btnMax.Name = "btnMax"
            Me.btnMax.Size = New System.Drawing.Size(21, 21)
            Me.btnMax.TabIndex = 14
            '
            'IM
            '
            Me.IM.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit
            Me.IM.ImageSize = New System.Drawing.Size(21, 21)
            Me.IM.ImageStream = CType(resources.GetObject("IM.ImageStream"), System.Windows.Forms.ImageListStreamer)
            Me.IM.TransparentColor = System.Drawing.Color.Transparent
            Me.KontrolniOkvir.ResumeLayout(False)

        End Sub

#End Region

#Region "Public Properties"

#Region "TextAlign"
        <DefaultValue(GetType(ContentAlignment), "MiddleCenter")> _
      Public Property TextAlign() As ContentAlignment
            Get
                Return mTextAlign
            End Get
            Set(ByVal Value As ContentAlignment)
                mTextAlign = Value
                Invalidate()
            End Set
        End Property
#End Region


#Region "Border Normal"
        <DefaultValue(GetType(Boolean), "False")> _
        Public Property BorderNormal() As Boolean
            Get
                Return mBorderNormal
            End Get
            Set(ByVal Value As Boolean)
                mBorderNormal = Value
                Invalidate()
            End Set
        End Property
#End Region

#Region "BackColor"
        <DefaultValue(GetType(Color), "221, 236, 254")> _
        Public Shadows Property BackColor() As System.Drawing.Color
            Get
                Return Me.mBackColor1
            End Get
            Set(ByVal Value As System.Drawing.Color)
                Me.mBackColor1 = Value
                If Me.DesignMode = True Then
                    Me.Invalidate()
                End If
            End Set
        End Property
        'Public Shadows Property MinimizeBox() As Boolean
        '    Get
        '        Return mMin
        '    End Get
        '    Set(ByVal Value As Boolean)
        '        Me.mMin = Value
        '        If Me.DesignMode = True Then
        '            Me.Invalidate()
        '        End If
        '    End Set
        'End Property
        'Public Shadows Property MaximizeBox() As Boolean
        '    Get
        '        Return mMax
        '    End Get
        '    Set(ByVal Value As Boolean)
        '        Me.mMax = Value
        '        If Me.DesignMode = True Then
        '            Me.Invalidate()
        '        End If
        '    End Set
        'End Property
        'Public Shadows Property ControlBox() As Boolean
        '    Get
        '        Return mKontrol
        '    End Get
        '    Set(ByVal Value As Boolean)
        '        Me.mKontrol = Value
        '        If Me.DesignMode = True Then
        '            Me.Invalidate()
        '        End If
        '    End Set
        'End Property
        'Public Property BackColor1() As Color
        '    Get
        '        Return mBackColor1
        '    End Get
        '    Set(ByVal Value As Color)
        '        If Value.Equals(Color.Empty) Then Value = mColorDefault
        '        mBackColor1 = Value
        '        Invalidate()
        '    End Set
        'End Property
#End Region

#Region "BackColor2"
        <DefaultValue(GetType(Color), "Color.FromArgb(129, 169, 226)")> _
        Public Property BackColor2() As Color
            Get
                Return mBackColor2
            End Get
            Set(ByVal Value As Color)
                If Value.Equals(Color.Empty) Then Value = mColorDefault
                mBackColor2 = Value
                Invalidate()
            End Set
        End Property
#End Region


#Region "Property GradientMode"
        <DefaultValue(GetType(Drawing2D.LinearGradientMode), "Vertical")> _
        Public Property GradientMode() As Drawing2D.LinearGradientMode
            Get
                Return mGradientMode
            End Get
            Set(ByVal value As Drawing2D.LinearGradientMode)
                mGradientMode = value
                Invalidate()
            End Set
        End Property
#End Region

#Region "Logo"
        <DefaultValue(GetType(Image), "Nothing")> _
        Public Property Logo() As Image
            Get
                Return mImage
            End Get
            Set(ByVal Value As Image)
                mImage = Value
                Invalidate()
            End Set
        End Property
#End Region
#Region "Max"
        Public Shadows Property MaximizeBox() As Boolean
            Get
                Return mMax
            End Get
            Set(ByVal Value As Boolean)
                mMax = Value
                If Me.DesignMode = True Then
                    Me.Invalidate()
                End If
            End Set
        End Property
#End Region

#Region "Min"
        Public Shadows Property MinimizeBox() As Boolean
            Get
                Return mMin
            End Get
            Set(ByVal Value As Boolean)
                mmin = Value
                If Me.DesignMode = True Then
                    Me.Invalidate()
                End If
            End Set
        End Property
#End Region
#End Region
#Region "Public Overrided Properties"

        <Browsable(True), DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)> _
      Public Overrides Property Text() As String
            Get
                Return MyBase.Text
            End Get
            Set(ByVal Value As String)
                MyBase.Text = Value
                Invalidate()
            End Set
        End Property

#End Region



#Region "Protected Overrided Methods"

#Region "-------> OnPaint Overrided Method"

        Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
            'MyBase.OnPaint(pe)
            'Dim p As New Point
            Dim c1 As Color
            Dim c2 As Color
            Me.Dock = DockStyle.Top


            c1 = mBackColor1
            c2 = mBackColor2
            PC.PaintGradientRectangle(e.Graphics, _
                                                  0, 0, Me.Width, Me.Height, _
                                                  c1, c2, mGradientMode)


            Dim ThisImage As Image
            If Not mImage Is Nothing Then
                ThisImage = mImage
                If mButtonType = HoverButtonType.HoverNormal Then
                    ThisImage = mImage
                Else
                    If mSelected Then
                        If Not (mImageSelected Is Nothing) Then
                            ThisImage = mImageSelected
                        End If
                    Else
                        ThisImage = mImage
                    End If
                End If


                Dim p As New Point
                p = PC.GetPointAligned(ThisImage.Size, New Point(0, 0), _
                                                       New Size(Me.Size.Width, Me.Size.Height), _
                                       5, 5, 5, 3, mImageAlign)

                e.Graphics.DrawImage(ThisImage, p.X, p.Y, ThisImage.Width, ThisImage.Height)
                Me.Height = ThisImage.Height
            Else
                Me.Height = 32
            End If

            Dim i As Int64
            i = Convert.ToInt16((Me.KontrolniOkvir.Height - Me.btnMin.Height) / 2)




            With Me.KontrolniOkvir
                .Parent = Me
                .Left = Convert.ToInt16(Me.Width - .Width)

            End With

            With Me.btnMin
                .Parent = Me.KontrolniOkvir
                .Top = i
                '.Dock = DockStyle.Right
                .Left = 0
                .Visible = mMin
            End With
            With Me.btnMax
                .Parent = Me.KontrolniOkvir
                .Top = i
                ' .Dock = DockStyle.Right

                .Left = 23
                .Visible = mMax
            End With

            With Me.btnclose
                .Parent = Me.KontrolniOkvir
                '.Dock = DockStyle.Right
                .Top = i
                .Left = 45

            End With
            f.Text = Me.Text
            PC.WriteText(e.Graphics, _
                                  Me.Text, Me.Font, _
                                  Me.TextAlign, _
                                  mTextQuality, _
                                  Me.ForeColor, _
                                  36, 0, Me.Width, Me.Height)

            ' Draw the border
            Dim mDrawBorder As Boolean = False
            Dim cb As Color
            If mMouseHover Then
                If mBorderHover Then
                    mDrawBorder = True
                    cb = mBorderHoverColor
                End If
            Else
                If mSelected Then
                    If mBorderSelected Then
                        mDrawBorder = True
                        cb = mBorderSelectedColor
                    End If
                Else
                    If mBorderNormal Then
                        mDrawBorder = True
                        cb = mBorderNormalColor
                    End If
                End If
            End If

            If mDrawBorder Then PC.PaintBorder(e.Graphics, 0, 0, Me.Width, Me.Height, cb)

        End Sub

#End Region

#End Region


        Private Sub btnMax_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMax.Click
            f.StartPosition = FormStartPosition.CenterScreen
            If Stanje = False Then f.WindowState = FormWindowState.Maximized : Stanje = True : Me.btnMax.Image = IM.Images(0) : Exit Sub
            If Stanje = True Then f.WindowState = FormWindowState.Normal : Me.btnMax.Image = IM.Images(1) : Stanje = False
            Me.Refresh()
        End Sub

        Private Sub btnMin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMin.Click

            f.WindowState = FormWindowState.Minimized
        End Sub

        Private Sub btnclose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnclose.Click
            f.Close()
        End Sub

        Protected Overrides Sub OnPaintBackground(ByVal pevent As System.Windows.Forms.PaintEventArgs)
   
        End Sub

        Protected Overrides Sub OnParentChanged(ByVal e As System.EventArgs)

        End Sub

        Protected Overrides Sub OnHandleCreated(ByVal e As System.EventArgs)
            f = Me.FindForm
            If f.WindowState = FormWindowState.Maximized Then Stanje = True Else Stanje = False
            If Stanje = True Then Me.btnMax.Image = Me.IM.Images(0) Else Me.btnMax.Image = Me.IM.Images(1)
        End Sub
    End Class

End Namespace

